echo $(upperme): $@ >&2
}
+function ssh255 {
+ ssh $@
+ sshret=$?
+
+ if [ $sshret -eq 255 ]; then
+ scottyerror "SSH connection failed!"
+ exit 1
+ else
+ return $sshret
+ fi
+}
+
function grepbackups {
- ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
+ ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
}
function isIncomplete {
- if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
+ if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
return 0
else
return 1
fi
}
-function isIncompleteOrNthDay {
- if isIncomplete || \
- [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
+function isNthDay {
+ if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
then
return 0
else
fi
}
+function latestTooOld {
+ for oldbackup in $(grepbackups); do
+ tstamp=$(echo $oldbackup | cut -d'-' -f1)
+
+ if [ $(( $(date +%s) - $tstamp )) -lt \
+ $(( $BACKUP_RUNEVERYNTHDAY*24*60*60 )) ]
+ then
+ return 1
+ fi
+ done
+
+ return 0
+}
+
function scottysync {
timestamp=$(date +%s)
rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
fi
- if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+ if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
- ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
+ ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
fi
if isIncomplete; then
if [ $? -eq 0 ]; then
scottyinfo Timestamping completed backup and linking to current backup
- ssh $REMOTE_HOST \
+ ssh255 $REMOTE_HOST \
"mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
fi
if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
scottyinfo Removing old backup $oldestbackup
- ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
+ ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
else
break
fi
}
function cleanup_abort {
- scottyinfo "No cleanup_abort function was defined."
-}
-
-function _cleanup_abort {
scottyerror "Caught exit signal! Cleaning up..."
- cleanup_abort
+ cleanup ABORT
if [ $(jobs -p) ]; then
scottyerror TERMinating remaining child processes...
kill $(jobs -p)
fi
+
deleteLock
+
exit
}
+function cleanup {
+ scottyinfo "No cleanup function was defined."
+}
+
function prepare {
scottyinfo "No prepare function was defined."
}
function cleanup_normal {
- scottyinfo "No cleanup_normal function was defined."
+ cleanup
+ deleteLock
}
function printhelp {
esac
done
- if ! isIncompleteOrNthDay; then
- scottyinfo "This is not the nth day and no incomplete backup exists."
+ ssh255 $REMOTE_HOST exit
+
+ if isNthDay; then
+ scottyinfo "This is the nth day."
+ elif latestTooOld; then
+ scottyinfo "The latest backup is too old."
+ else
+ scottyinfo "No backup has to be done. Exiting."
exit 0
fi
- trap _cleanup_abort EXIT
+ scottyinfo "Performing backup."
+
+ trap cleanup_abort EXIT
prepare
scottysync
- cleanup_normal
- trap deleteLock EXIT
+ trap cleanup_normal EXIT
exit 0
}